clear all
clf

filename_us = 'New data\Attenuation\Adb_attenuation_30v_3p_t4_us_signal.txt';
filename_trig = 'New data\Attenuation\Adb_attenuation_30v_3p_t4_us_trig.txt';
movie_name = 'take4.avi';
measurements = dlmread(filename_us);
trig = dlmread(filename_trig);
% Remove startup noise 
st_noise_l = 700;
c_measurements = measurements(:,st_noise_l:end);

nr_of_measurements = size(c_measurements,1);

%Convert samples to cm.
%2d = t*c
%ca-ca conversion
f = 14.29e+6;
sample_t = 1/f;
c = 1500;
samples = st_noise_l:size(measurements,2);
d = 1/2*(sample_t*c.*samples);

n_measurements = normalize(c_measurements);
hfig = figure(1);
axis tight
%Movie related
%set(gcf, 'Color','white')
%set(gca, 'nextplot','replacechildren', 'Visible','off');

rect = get(hfig,'Position'); 
rect(1:2) = [-100 -100]; 

%# create AVI object
nFrames = nr_of_measurements;
vidObj = VideoWriter(movie_name);
vidObj.Quality = 30;
vidObj.FrameRate = 10;
open(vidObj);
%
p1 = [];
for i=1:nr_of_measurements
    [maxVal,maxInd] = max(n_measurements(i,:));
    mDMax = 1/2*(sample_t*c*(maxInd+st_noise_l));
    [minVal,minInd] = min(n_measurements(i,:));
    mDMin = 1/2*(sample_t*c*(minInd+st_noise_l));
    
    
    %plotting
    if ~isempty(p1)
        delete(p1)
    end
    %subplot(2,1,1)
    p1 = plot(d,n_measurements(i,:));
    hold on
    plot(mDMax,maxVal,'ro')
    hold on 
    plot(mDMin,minVal,'ro')
    hold on
    axis([d(1) d(end) -0.8 0.8])
    writeVideo(vidObj, getframe(gca,rect));
%     subplot(2,1,2)
%     plot(trig(i,:))
%     axis([1 500 0 2])
    %pause(0.5)
    i
end
close(vidObj);