clear all,close all
% import test-set
path = 'New data\Bubbles\';

data_files_bubbles = {'Adb_30v_5p_mrk1_bubtest_us_signal.txt';
                      'Adb_30v_4p_mrk1_bubtest2_us_signal.txt';
                      'Adb_30v_4p_mrk1_bubtest3_us_signal.txt';
                      'Adb_30v_4p_mrk1_bubtest4_us_signal.txt'};
data_files_trigs = {'Adb_30v_5p_mrk1_bubtest_us_trig.txt';
                      'Adb_30v_4p_mrk1_bubtest2_us_trig.txt';
                      'Adb_30v_4p_mrk1_bubtest3_us_trig.txt';
                      'Adb_30v_4p_mrk1_bubtest4_us_trig.txt'};
  

nr_files = size(data_files_bubbles,1);
us_data = cell(nr_files,1);
us_trig = cell(nr_files,1);
for i=1:nr_files
    us_data{i} = dlmread([path data_files_bubbles{i}]);
    us_trig{i} = dlmread([path data_files_trigs{i}]);
end

%Inspection
% figure(10)
% for k=1:nr_files
%     nr_of_mes = size(us_data{k},1);
%     for i=1:nr_of_mes
%         
%         subplot(2,1,1)
%         plot(us_data{k}(i,:))
%         axis([0 20000 -1 1])
%         subplot(2,1,2)
%         plot(us_trig{k}(i,:))
%         axis([0 1000 0 3])
%         pause(0.1)
%     end
% end

%test
var_limit = 0.0001;
st_noise = 700;
mV = cell(4,1);
mI = cell(4,1);
variances = cell(nr_files,1);
disc_vals = [];
bool_newtrig_on = 'false';
newtrig_ind = cell(4,1);
for k = 1:nr_files
    max_echo_val = [];
    max_echo_ind = [];
    newtrig_mes = [];
    nr_of_mes = size(us_data{k},1);
    variance = zeros(nr_of_mes,1);
    us_data{k} = remove_stnoise(st_noise,us_data{k});
    us_data{k} = normalize(us_data{k});
    for i = 1:nr_of_mes
        variance(i) = var(us_data{k}(i,:));
        %if variance(i) > var_limit
            [tmp_val,tmp_ind] = max(us_data{k}(i,:));
            if tmp_val < 1
                max_echo_val = [max_echo_val;tmp_val i];
                max_echo_ind = [max_echo_ind;tmp_ind i];
            end
            if strcmp(identify_trig(us_trig{k}(i,:)),'580kHz') && ~bool_newtrig_on
                bool_newtrig_on = 'true';
                newtrig_mes = [newtrig_mes;i];
            end
        %else
            %disc_mes = 
        %end
    end
    mV{k} = max_echo_val;
    mI{k} = max_echo_ind;
    newtrig_ind{k} = newtrig_mes;
    
    variances{k} = variance;
    
    figure(k)
    plot(mV{k}(:,2),mV{k}(:,1),'--b')
    hold on
    plot(newtrig_ind{k},0.5*ones(length(newtrig_ind{k}),1),'r+')
   
end
k = 1;
l1 = [627,735];
m_n = size(mV{k},1);
figure(k)
plot(mV{k}(1:l1(1),2),mV{k}(1:l1(1),1),'--b','LineWidth',2)
hold on
plot(mV{k}(l1(1):l1(2),2),mV{k}(l1(1):l1(2),1),'--r','LineWidth',2)
hold on
plot(mV{k}(l1(2):end,2),mV{k}(l1(2):end,1),'--b','LineWidth',2)
axis([0 m_n 0 1.5])
hleg1 = legend('Amplitude with 1MHz trigger','Amplitude with 580kHz trigger');
xlabel('Measurement number')
ylabel('Amplitude')
title('Bubble test 1')

k = 2;
l1 = [252,357];
m_n = size(mV{k},1);
figure(k)
plot(mV{k}(1:l1(1),2),mV{k}(1:l1(1),1),'--b','LineWidth',2)
hold on
plot(mV{k}(l1(1):l1(2),2),mV{k}(l1(1):l1(2),1),'--r','LineWidth',2)
hold on
plot(mV{k}(l1(2):end,2),mV{k}(l1(2):end,1),'--b','LineWidth',2)
axis([0 m_n 0 1.5])
hleg1 = legend('Amplitude with 1MHz trigger','Amplitude with 580kHz trigger');
xlabel('Measurement number')
ylabel('Amplitude')
title('Bubble test 2')
