clear all, close all
path = 'New data\Diesel\';

pre_s = 'diesel_layer_mrk';
ls_std_trg  = '_30v_stdtrig_3dl_diesel_us_signal.txt';
ls_new_trg = '_30v_stdtrig_5dl_diesel_us_signal.txt';
diesel_data_stdtrg = cell(4,1);
diesel_data_newtrg = cell(4,1);
st_noise = 700;
for m=1:4
    diesel_data_stdtrg{m} = dlmread([path pre_s num2str(m) ls_std_trg]);
    diesel_data_newtrg{m} = dlmread([path pre_s num2str(m) ls_new_trg]);
    
    %set st_noise to 0
    diesel_data_stdtrg{m} = remove_stnoise(st_noise, diesel_data_stdtrg{m});
    diesel_data_newtrg{m} = remove_stnoise(st_noise, diesel_data_newtrg{m});
    
    %normalize
    diesel_data_stdtrg{m} = normalize(diesel_data_stdtrg{m});
    diesel_data_newtrg{m} = normalize(diesel_data_newtrg{m});
    
end
% avg_diesel_data_stdtrg1 = average_measurement2(diesel_data_stdtrg{1,1},10);
% figure(6)
% samples_to_time = 1/(14.3e+6).*(1:1:size(avg_diesel_data_stdtrg1,2));
% samples_to_time = (1e+6)*samples_to_time;
% plot(samples_to_time,avg_diesel_data_stdtrg1(10,:),'LineWidth',2)
% xlabel('time [s]')
% ylabel('voltage [V]')
% title('Diesel layer on top of adblue')
% 
% figure(7)
% plot(diesel_data_stdtrg{2,1}(1,:))
% figure(8)
% plot(diesel_data_stdtrg{3,1}(1,:))
% figure(9)
% plot(diesel_data_stdtrg{4,1}(1,:))
    
    
RTT_vals = cell(4,1);
RTT_inds = cell(4,1);
main_echo_ind = cell(4,1);
var_limit = 0.0001;
echoes_ind = cell(4,1);
for m=1:4
    l = size(diesel_data_stdtrg{m},1);
    [e_i_temp,main_e_ind,RTT_i_temp,RTT_v_temp ,var,disc] = find_echos_and_RTT(diesel_data_stdtrg{m},var_limit,st_noise);
    RTT_vals{m} = RTT_v_temp;
    RTT_inds{m} = RTT_i_temp;
    main_echo_ind{m}  = main_e_ind;
    echoes_ind{m} = e_i_temp;
end

% for k = 1:4
%     figure(k)
%     h = size(echoes_ind{k},1);
%     tmp_arr = echoes_ind{k};
%     for i=1:h
%         tmp = tmp_arr{i};
%         plot(tmp(:,2),tmp(:,1),'r*')
%         hold on
%     end
% end
freq_inds = cell(4,1);
for k = 1:4
    figure(k)
    h = size(echoes_ind{k},1);
    tmp_arr = echoes_ind{k};
    e_i = [];
    e_a = [];
    for i=1:h
        tmp = tmp_arr{i};
        e_i(1:numel(tmp(:,2)),i) = tmp(:,2);
        e_a(1:numel(tmp(:,1)),i) = tmp(:,1);
    end
    plottet_inds = [];
    for i=1:size(e_i,1)
        t_i = e_i(i,:);
        t_a = e_a(i,:);
        if isempty(plottet_inds)
            h1 = plot(1e+6*(1/14.3e+6)*median(t_i(t_i~= 0)),median(t_a(t_a ~= 0)),'ro');
            plottet_inds = [plottet_inds;median(t_i(t_i ~= 0))];
            hold on
        else
            plotB = 0;
            for j=1:size(plottet_inds,1)
                if median(t_i(t_i~= 0)) - plottet_inds(j) < 100
                   plotB = 1;
                end
            end
            if plotB == 0
                plot(1e+6*(1/14.3e+6)*median(t_i(t_i~= 0)),median(t_a(t_a ~= 0)),'ro');
                plottet_inds = [plottet_inds;median(t_i(t_i ~= 0))];
                hold on
            end
        end 
    end
    freq_inds{k} = plottet_inds;
%     avg_mes = average_measurement2(diesel_data_stdtrg{k,1},5);
%     l = size(avg_mes,2);
%     samples_to_time = 1/(14.3e+6).*(1:1:l);
%     samples_to_time = (1e+6)*samples_to_time;
%     h2 = plot(samples_to_time,avg_mes,'b','LineWidth',2);
%     xlabel('time [s]')
%     ylabel('voltage [V]')
%     legend([h1 h2(1)],'Detected echoes','Measurement')
%     title(['Diesel layer test ' num2str(k) ' 3dL ' ])
end

%Freq-analysis
w_size = 500;
psd_e1 = cell(4,1);
psd_e2 = cell(4,1);
for k = 1:4
    figure(4+k)
    data = diesel_data_stdtrg{k};
    echo_locs = freq_inds{k};
    e1s = [];
    e2s = [];
    for i=1:size(data,1)
        [e1_PSD,f1] = periodogram_func(data(i,round(echo_locs(1)-w_size):round(echo_locs(1)+w_size)));
        [e2_PSD,f2] = periodogram_func(data(i,round(echo_locs(2)-w_size):round(echo_locs(2)+w_size)));
        e1s = [e1s;e1_PSD];
        e2s = [e2s;e2_PSD];
%         figure(200)
%         subplot(2,1,1)
%         plot(data(i,echo_locs(1)-w_size:echo_locs(1)+w_size))
%         subplot(2,1,2)
%         plot(data(i,echo_locs(2)-w_size:echo_locs(2)+w_size))
%         pause(0.3)
%         figure(199)
%         subplot(2,1,1)
%         plot(f1,e1_PSD)
%         subplot(2,1,2)
%         plot(f2,e2_PSD)
%         pause(0.3)
    end
    psd_e1{k} = e1s;
    psd_e2{k} = e2s;
    subplot(2,1,1)
    plot(f1/(1e6),mean(psd_e1{k}),'LineWidth',2)
    xlabel('Frequency [MHz]')
    ylabel('Power')
    title('PSD for first adblue-diesel echo')
    subplot(2,1,2)
    plot(f2/(1e6),mean(psd_e2{k}),'LineWidth',2)
    xlabel('Frequency [MHz]')
    ylabel('Power')
    title('PSD for first diesel-air echo')
    
end







        

   