function [final_cands,noise_bit] = echo_detection(measurement,proximity,prev_main_echo,st_noise)
%Detailed explanation goes here
%Measurement should be a pre-processed i.e. averaged,normalized,start-up
%noise set to zero.
%Proximity is an index that is supposed to hold information about the last
%whereabouts of the echo


%Vib setting:
% th1 = 1/2*max(mes_envelope(:,1));
% th2 = 1/2*th1;
% th1_1MHz = 1/2*max(corr_1MHz_env(:,1));
% th2_1MHz = 1/2*th1;
% th1_580kHz = 1/2*max(corr_580kHz_env(:,1));
% th2_580kHz = 1/2*th1;

%Diesel settings
% th1 = 1/5*max(mes_envelope(:,1));
% th2 = 1/2*th1;
% th1_1MHz = 1/5*max(corr_1MHz_env(:,1));
% th2_1MHz = 1/2*th1;
% th1_580kHz = 1/5*max(corr_580kHz_env(:,1));
% th2_580kHz = 1/2*th1;

%============================ TUNING COEFF ================================
%3 dl = 1/10
a_env = 1/2;
b_env = 1/2;
a1MHz = 1/2;
b1MHz = 1/2;
a580kHz = 1/2;
b580kHz = 1/2;

%Used to say something about if it is a good idea to measure?
    tot_mes_energy = signal_energy_window2(measurement);
    env_indices = [];
    mes_envelope = signal_envelope(measurement);
    noise_bit = check_for_noise(mes_envelope);
    % ================== Detection based on envelope ==========================
    th1 = a_env*max(mes_envelope(:,1));
    th2 = b_env*th1;
    env_indices = locate_echoes_from_envelope(mes_envelope,th1,th2);
    
    %======================== CONSTRUCT CORR PULSES ===========================
    %Method 2 (toneburst) seems best
    sampl_freq = 14.3e6;
    %====== Construct 1 MHz sine-waves =====
    signal_freq_1MHz = 1e6;

    %===Important parameters 1MHz===
    samples_1MHz = 100;
    Ampl_1MHz = 0.5;
    %===============================

    signal_period = sampl_freq/signal_freq_1MHz;
    num_cycles = floor(samples_1MHz/signal_period);

    %Method 1
    t = 0:1/sampl_freq:1/sampl_freq*samples_1MHz;
    corr_pulse_1MHz_1 = Ampl_1MHz*sin(2*pi*signal_freq_1MHz*t);
    % corr_1MHz_1 = xcorr(corr_pulse_1MHz_1,measurement);

    %Method 2
    corr_pulse_1MHz_2  =  toneBurst(sampl_freq, signal_freq_1MHz, num_cycles);
    corr_pulse_1MHz_2 = Ampl_1MHz*corr_pulse_1MHz_2;


    %====== Construct 580 kHz sine-waves =====
    signal_freq_580kHz = 580e5;

    %===Important parameters 580 kHz===
    samples_580kHz = 100;
    Ampl_580kHz = 0.5;
    %==================================

    signal_period = sampl_freq/signal_freq_580kHz;
    num_cycles = floor(samples_580kHz/signal_period);

    %Method 1
    t = 0:1/sampl_freq:1/sampl_freq*samples_580kHz;
    corr_pulse_580kHz_1 = Ampl_580kHz*sin(2*pi*signal_freq_580kHz*t);
    % corr_580kHz_1 = xcorr(corr_pulse_580kHz_1,measurement);

    %Method 2
    corr_pulse_580kHz_2  =  toneBurst(sampl_freq, signal_freq_580kHz, num_cycles);
    corr_pulse_580kHz_2 = Ampl_580kHz*corr_pulse_580kHz_2;

    %============ CALCULATE ECHO LOCATIONS BASED ON CORRELATION ===============
    %Calc corr
    corr_1MHz_2 = xcorr(measurement,corr_pulse_1MHz_2);
    corr_1MHz_env = signal_envelope(corr_1MHz_2);
    %=========== IMPORTANT TUNING PARAMETERS =========== 
    th1_1MHz = a1MHz*max(corr_1MHz_env(:,1));
    th2_1MHz = b1MHz*th1;
    %===================================================

    corr_1MHz_indeces = locate_echoes_from_envelope(corr_1MHz_env,th1_1MHz,th2_1MHz); 

    corr_580kHz_2 = xcorr(measurement,corr_pulse_580kHz_2);
    corr_580kHz_env = signal_envelope(corr_580kHz_2);
    %=========== IMPORTANT TUNING PARAMETERS =========== 
    th1_580kHz = a580kHz*max(corr_580kHz_env(:,1));
    th2_580kHz = b580kHz*th1;
    %===================================================
    corr_580kHz_indeces = locate_echoes_from_envelope(corr_580kHz_env,th1_580kHz,th2_580kHz);

    cross_corr_l = size(corr_1MHz_2,2);
    midInd = floor(cross_corr_l/2);


    %Corr indices are ordered the wrong way. Flipud and then print
   
    if ~isempty(corr_580kHz_indeces)
        corr_indeces_580kHz = corr_580kHz_indeces(:,2)-midInd;
        c_580kHz_l = size(corr_indeces_580kHz,1);
    else
        corr_indeces_580kHz = [];
    end
    if ~isempty(corr_1MHz_indeces)
        corr_indeces_1MHz = corr_1MHz_indeces-midInd;
        c_1MHz_l = size(corr_indeces_1MHz,1);
    else
        corr_indeces_1MHz = [];
    end

        %=== IMPORTANT TUNING PARAMETRE ====
    c_window = 300;
    window_corr_env = 300;
    %===================================
    if ~isempty(env_indices)
        echo_env_indices = env_indices(:,2);
        env_l = size(echo_env_indices,1);
        if ~isempty(corr_1MHz_indeces)
            corr_indeces_1MHz = corr_1MHz_indeces(:,2)- midInd;
            c_1MHz_l = size(corr_indeces_1MHz,1);
        else
            corr_indeces_1MHz = echo_env_indices;
            c_1MHz_l = size(corr_indeces_1MHz,1);
        end
        if ~isempty(corr_580kHz_indeces)
            corr_indeces_580kHz = corr_580kHz_indeces(:,2)-midInd;
            c_580kHz_l = size(corr_indeces_580kHz,1);
        else
            corr_indeces_580kHz = echo_env_indices;
            c_1MHz_l = size(corr_indeces_1MHz,1);
        end
    end
    corr_cands = [];
    final_cands = [];
    if (max(corr_580kHz_env(:,1)) < max(corr_1MHz_env(:,1))) && (~isempty(corr_indeces_1MHz)) && (~isempty(corr_indeces_580kHz))
        %disp('1MHz corr stronger than 580kHz')
        for i=1:c_1MHz_l
            for j=1:c_580kHz_l
                if abs(corr_indeces_1MHz(i)-corr_indeces_580kHz(j)) < c_window
                    tmp = measurement(round((corr_indeces_1MHz(i)+corr_indeces_580kHz(j))/2));
                    corr_cands = [corr_cands;tmp round((corr_indeces_1MHz(i)+corr_indeces_580kHz(j))/2)];
                end
            end
        end
        if isempty(env_indices)
            final_cands = corr_cands;
            return
        end
        corr_cands_l = size(corr_cands,1);
        for i=1:env_l
            for j=1:corr_cands_l
                if abs(echo_env_indices(i) - corr_cands(j,2)) < window_corr_env
                    final_cands = [final_cands; env_indices(i,1) round((echo_env_indices(i) + corr_cands(j,2))/2)];
                end
            end
        end
    else
        if isempty(env_indices)
            final_cands = corr_cands;
            return
        end
        %disp('580 corr stronger than 1 MHz')
        for i=1:env_l
            for j=1:c_580kHz_l
                if abs(echo_env_indices(i) - corr_indeces_580kHz(j)) < window_corr_env
                    final_cands = [final_cands;env_indices(i,1) round((echo_env_indices(i) + corr_indeces_580kHz(j))/2)];
                end
            end
        end
    end
    final_cands;



    %============================== PLOTTING ==================================
    plotting = 0;
        if plotting == 1
        %=========== GENERAL STUFF =============

%         figure(2)
%         set(gca,'XTickLabel',num2str(get(gca,'XTick').'))
%         subplot(4,1,1)
%         plot(measurement)
%         hold off
%         subplot(4,1,2)
%         plot(corr_pulse_1MHz_1)
%         hold on
%         plot(corr_pulse_580kHz_1,'r')
%         hold off
%         subplot(4,1,3)
%         plot(corr_pulse_1MHz_2)
%         hold on
%         plot(corr_pulse_580kHz_2,'r')
%         hold off
%         subplot(4,1,4)
%         plot(mes_envelope(:,2),mes_envelope(:,1),'LineWidth',2)
%         hold on
%         plot(measurement,'r')
%         hold off

        %========== ENVELOPE PLOTTING ============
        figure(3)
        h1 = plot(mes_envelope(:,2),mes_envelope(:,1),'LineWidth',2);
        hold on
        for i=1:size(env_indices(:,1),1)
            h2 = plot(env_indices(i,2),env_indices(i,1),'r+','LineWidth',2);
            hold on
        end
        h3 = plot(get(gca,'xlim'), [th1 th1],'g','LineWidth',2); 
        hold on
        h4 = plot(get(gca,'xlim'), [th2 th2],'cy','LineWidth',2); 
        legend([h1(1) h2(1) h3(1) h4(1)],'Amplitude Envelope','Detected echoes','Treshold 1','Treshold 2')
        xlabel('Samples')
        ylabel('Voltage')
        hold off

        %=========== CORRELATION ================
        figure(5)

        subplot(4,1,1)
        plot(corr_1MHz_2)
        hold on
        plot(corr_1MHz_env(:,2),corr_1MHz_env(:,1),'r')
        hold off

        subplot(4,1,2)
        plot(corr_1MHz_env(:,2),corr_1MHz_env(:,1))
        hold on
        for i=1:size(corr_1MHz_indeces(:,1),1)
            plot(corr_1MHz_indeces(i,2),corr_1MHz_indeces(i,1),'r+')
            hold on
        end
        plot(get(gca,'xlim'), [th1_1MHz th1_1MHz],'g'); 
        hold on
        plot(get(gca,'xlim'), [th2_1MHz th2_1MHz],'cy'); 
        hold off

        subplot(4,1,3)
        plot(corr_580kHz_2)
        hold on
        plot(corr_580kHz_env(:,2),corr_580kHz_env(:,1),'r')
        hold off

        subplot(4,1,4)
        plot(corr_580kHz_env(:,2),corr_580kHz_env(:,1))
        hold on
        for i=1:size(corr_580kHz_indeces(:,1),1)
            plot(corr_580kHz_indeces(i,2),corr_580kHz_indeces(i,1),'r+')
            hold on
        end
        plot(get(gca,'xlim'), [th1_580kHz th1_580kHz],'g'); 
        hold on
        plot(get(gca,'xlim'), [th2_580kHz th2_580kHz],'cy'); 
        hold off
        pause(1)


        %============ FINAL CANDIDATES ==============
%         figure(6)
%         plot(measurement)
%         hold on
%         y_vals = 0.2*ones(length(final_cands),1);
%         plot(final_cands,y_vals,'r*')
%         hold off
%         end
%         pause(0.2)



end

