clear all
%Script made to compare amplitude of different distance, different voltage
%and different number of pulses in trigger
%Path is relative to the directory of this m-file.
path = 'New data\Floater constant level remade\3 pulses';
w_path = 'Results';

name = [path(10:end) '.txt'];
name = regexprep(name,'\',' ');

s_1p_nofloat = dir(path);
tfiles_1Pnf = char(s_1p_nofloat.name);

file_nr = size(tfiles_1Pnf,1);
chars = size(tfiles_1Pnf,2);
%extract us files
%predecleration should be done
us_files16v = [];
us_files30v = [];
for i=1:file_nr
    if(~isempty(strfind(tfiles_1Pnf(i,:), 'us_signal')))
        if(~isempty(strfind(tfiles_1Pnf(i,:), '16v')))
            us_files16v = [us_files16v;tfiles_1Pnf(i,:)];
        end
        if(~isempty(strfind(tfiles_1Pnf(i,:), '30v')))
            us_files30v = [us_files30v;tfiles_1Pnf(i,:)];
        end
    end
end


%Remember to use strtrim before looking up files (seemingly not necesssary)
us_file_nr = size(us_files16v,1);
st_noise_l = 500;
for i=1:us_file_nr
    %Read data files
    
    data_16v{i} = dlmread([path '/' us_files16v(i,:)]);
    data_30v{i} = dlmread([path '/' us_files30v(i,:)]);
    
    %Chop-startup, normalize
    tt16 = data_16v{1,i};
    tt16 = tt16(:,st_noise_l:end);
    tt16 = normalize(tt16);
    data_16v{1,i} = tt16;
    
    tt30 = data_30v{1,i};
    tt30 = tt30(:,st_noise_l:end);
    tt30 = normalize(tt30);
    data_30v{1,i} = tt30;
    
    %Find max amplitudes
    
    %16v
    ampl_16v_t = [];
    pos_max16v = [];
    w16 = data_16v{1,i};
    for l=1:size(w16,1)
        [max_16v_t,pos_16v] = max(w16(l,:));
        ampl_16v_t = [ampl_16v_t;max_16v_t];
        pos_max16v = [pos_max16v;pos_16v];
    end
    ampl_16v{i} = ampl_16v_t;
    max_pos_16v{i} = pos_max16v;
    
    %30v
    ampl_30v_t = [];
    pos_max30v = [];
    w30 = data_30v{1,i};
    for l=1:size(w30,1)
        [max_30v_t,pos_30v] = max(w30(l,:));
        ampl_30v_t = [ampl_30v_t;max_30v_t];
        pos_max30v = [pos_max30v;pos_30v];
    end
    ampl_30v{i} = ampl_30v_t;
    max_pos_30v{i} = pos_max30v;
end



%Take median of amplitude
med_max_ampl16v = zeros(1,us_file_nr);
med_max_ampl30v = zeros(1,us_file_nr);
for i=1:us_file_nr
    temp16 = ampl_16v{1,i};
    med_max_ampl16v(i) = median(temp16);
    
    temp30 = ampl_30v{1,i};
    med_max_ampl30v(i) = median(temp30);
end
   
%Plot
figure(1)
div_30_16 = zeros(1,us_file_nr);
for i=1:us_file_nr
    max_pos_16v{i}(1)
    max_pos_30v{i}(1)
    if i==1
        figure(1)
        plot(16,med_max_ampl16v(i),'r+')
        hold on
        plot(16,med_max_ampl30v(i),'bo')
        hold on
        axis([0 100 0 1])
        
        figure(2)
        plot(16,med_max_ampl30v(i)/med_max_ampl16v(i),'r+')
        hold on
        axis([0 100 1 2])
    elseif i==6
        figure(1)
        plot((i-1)*16+14,med_max_ampl16v(i),'r+')
        hold on
        plot((i-1)*16+14,med_max_ampl30v(i),'bo')
        hold on
        axis([0 100 0 1])
        
        figure(2)
        plot((i-1)*16+14,med_max_ampl30v(i)/med_max_ampl16v(i),'r+')
        hold on
        axis([0 100 1 2])
    else
       figure(1)
       plot(i*16,med_max_ampl16v(i),'r+')
       hold on
       plot(i*16,med_max_ampl30v(i),'bo')
       hold on
       axis([0 100 0 1])
       
       figure(2)
       plot(i*16,med_max_ampl30v(i)/med_max_ampl16v(i),'r+')
       hold on
       axis([0 100 1 2])
    end
    div_30_16(i) = med_max_ampl30v(i)/med_max_ampl16v(i);
end

%Write to file, format is 16 v 1st line, 30v 2nd line
res = [med_max_ampl16v;med_max_ampl30v;div_30_16];
disp('distance in samples to maximums')

dlmwrite([w_path '/' name],res);


    
