clear all, close all
sim_path = 'Results\K-wave\';
data_files_simulation =['simulation__PL=0.1__PR=0.032__Freq=1MHz__CYCLES=15__ABSORBTION=false.txt'
                        'simulation__PL=0.2__PR=0.032__Freq=1MHz__CYCLES=15__ABSORBTION=false.txt';
                        'simulation__PL=0.3__PR=0.032__Freq=1MHz__CYCLES=15__ABSORBTION=false.txt';
                        'simulation__PL=0.4__PR=0.032__Freq=1MHz__CYCLES=15__ABSORBTION=false.txt';
                        'simulation__PL=0.5__PR=0.032__Freq=1MHz__CYCLES=15__ABSORBTION=false.txt';
                        'simulation__PL=0.6__PR=0.032__Freq=1MHz__CYCLES=15__ABSORBTION=false.txt';
                        'simulation__PL=0.7__PR=0.032__Freq=1MHz__CYCLES=15__ABSORBTION=false.txt';
                        'simulation__PL=0.8__PR=0.032__Freq=1MHz__CYCLES=15__ABSORBTION=false.txt';
                        'simulation__PL=1.0__PR=0.032__Freq=1MHz__CYCLES=15__ABSORBTION=false.txt';];
                        
nr_sim_files = size(data_files_simulation,1);
max_points = [];
sim_data = cell(nr_sim_files,1);
for i=1:nr_sim_files
    sim_data{i} = dlmread([sim_path data_files_simulation(i,:)]);
    tmp_vals = sim_data{i}(1,:);
    max_points = [max_points;max(tmp_vals(round(end/2):end))];
end
%formula for converting sim_time to dist: *(1630/2)
sim_lengths = [10;20;30;40;50;60;70;80;100];

res_path = 'Results\';
data_files_res = ['Adb_1p_floater.txt';
                  'Adb_2p_floater.txt';
                  'Adb_3p_floater.txt';
                  'Adb_4p_floater.txt';];
              
nr_res_files = size(data_files_res,1);
res_data = [];
for i=1:nr_res_files
    res_data = [res_data;dlmread([res_path data_files_res(i,:)])];
end

st_noise = 700;
mv_mark_1p = dlmread('New data\Moving mrk 1-6\1 pulse\Adb_1202_1p_mrk1-6_30v_us_signal.txt');

mv_mark_1p = remove_stnoise(st_noise,mv_mark_1p);
mv_mark_1p = normalize(mv_mark_1p);
figure(2)
mv_l = size(mv_mark_1p,1);
mv_max_pt = zeros(mv_l,1);
mv_max_ind = zeros(mv_l,1);
for i=1:mv_l
    [mv_max_pt(i),mv_max_ind(i)] = max(mv_mark_1p(i,:));
end
%normalize
%convert max_indeces to level
mv_max_ind = 1/(14.3e+6).*mv_max_ind*(1630/2);
mv_max_ind = mv_max_ind*100;
mv_max_pt = mv_max_pt./max(mv_max_pt);


res_lengths = [16:16:96]; %[cm]
res_4p = res_data(end,:);
res_3p = res_data(end-2,:); 
res_2p = res_data(end-4,:); 
res_1p = res_data(end-6,:);
%Normalize to compare 
norm_res_sim = max_points./(max(max_points));
norm_res_4p = res_4p/max(res_4p);
norm_res_3p = res_3p/max(res_3p);
norm_res_2p = res_2p/max(res_2p);
norm_res_1p = res_1p/max(res_1p);




figure(1)
plot(res_lengths,norm_res_4p,'--r*','LineWidth',2)
hold on
plot(res_lengths,norm_res_3p,'--g*','LineWidth',2)
hold on
plot(res_lengths,norm_res_2p,'--cy*','LineWidth',2)
hold on
plot(res_lengths,norm_res_1p,'--y*','LineWidth',2)
hold on

plot(sim_lengths, norm_res_sim,'b','LineWidth',2)
hleg1 = legend('experiment results 4p','experiment results 3p','experiment results 2p','experiment results 1p','simulation results');
axis([10 100 0 1.2])
xlabel('Level')
ylabel('max amplitude')
title('Simulation compared with experimental data')

figure(2)
plot(mv_max_ind,mv_max_pt,'--b*','LineWidth',2)
xlabel('Level')
ylabel('amplitude')
set(gca,'fontsize',14)

%end

                       